// UrsNTPTimeSource.h
//
// Autor: http://UllisRoboterSeite.de
// Doku:  http://bienonline.magix.net/public/esp8266-UrsTime.html
//
// s. UrsTime.h

#ifndef _URSNTPTIMESOURCE_h
#define _URSNTPTIMESOURCE_h

#include <Arduino.h>
#include <UrsTimeSource.h>
#include <WiFiUdp.h>

class UrsNTPTimeSource : public UrsTimeSource {
private:
  // Abzufragende NTP-Server:
  static const uint8_t retryAfter = 10; // Anzahl Sperrzyklen
  static const uint8_t maxServers = 10; // Maximalanzahl an verwaltbaren NTP-Servern
  uint8_t servers = 0;                  // Anzahl der aktuell registrierten Server
  String serverNames[maxServers];       // Liste der Server-Namen
//  uint8_t serverReaminingLoops[maxServers]; // Anzahl verbleibender gesperrter Abfragen
  
  static const int NTP_PACKET_SIZE = 48; // Die NTP-Zeitangabe befindet sich in den ersten 48 Byte des Pakets
  byte packetBuffer[NTP_PACKET_SIZE];    // Puffer fr eingehende und ausgehende Pakete
  WiFiUDP Udp;
  uint16_t NTPPort = 123; // Port zum Datenaustausch mit dem NTP-Server
  uint32_t timeOut = 1500;     // Timeout fr die Zeitanfrage in Millisekunden

  bool getNtpTime(String ntpServerName);  // Fragt die Zeit beim angegeben Server ab.

public:
  UrsNTPTimeSource() {}
  UrsNTPTimeSource(String ntpServername) { addNTPServer(ntpServername); }
  UrsNTPTimeSource(String sn1, String sn2) { addNTPServer(sn1); addNTPServer(sn2);  }
  UrsNTPTimeSource(String sn1, String sn2, String sn3) { addNTPServer(sn1); addNTPServer(sn2); addNTPServer(sn3); }
  bool addNTPServer(String ntpServername); // true, wenn der Name erfolgreich hinzugefgt werden konnte
  virtual UrsTimeSourceState loadTime();
};

#endif