// UrsTime
//
// Autor: http://UllisRoboterSeite.de
// Doku:  http://bienonline.magix.net/public/esp8266-UrsTime.html
// Created: 2017-10-07
//
// Version 1.0 (2017-10-07)
// - Basis-Version
//
// Version 1.1 (2017-10-11)
// - Korrektur einiger Fehler
//
// Version 1.2 (2017-12-16)
// - Neue Methode 'UrsTimeElements toLocalTime(time_t timeStamp)' rechnet UNIX-Zeitstempel in lokale Zeit um.
// - toString erstellt aus UrsTimeElements mit Formatangeben analog strftime().
// - Einige Methoden und Methoden-Argumente mit 'const'-Attribut vershehen.
// - Exceptions beim Zugriff auf PROGMEM bei monthStr() und dayStr() bei deutschen Texten behoben.
// - Default-Language und Default-Format bei UrsTimeElements eingefhrt.
// - UrsTimeElements von Printable abgeleitet.
//
// Version 1.3 (2018-03-12)
// - Methode UrsSystemTimeServer::synchronize() hinzugefgt
//
// Version 1.4 (2018-03-12)
// - Die Sperren fr Zeitserver entfernt. Synchronisationsintervalle werden von auen geregelt.
// - Konstruktor ohne Servername hinzugefgt.
//
// Version 1.5 (2018-03-21)
// - UrsTimeElements hat ein neues Feld OffsetUTC: Offset der Timezone zu UTC in Sekunden.
// - UrsSystemTimeServer, neue Methode: currentOffsetUTC(): Offset der eigestellten Timezone zu UTC in Sekunden.
// - debugOffset hinzugefgt
//
// Version 1.6 (2018-03-30)
// - Es wurde fehlerhaft MEZ anstatt der bergebenen Zeitzone zur Umrechnung verwandt.
//
// Version 1.7 (2020-07-28)
// - Compiler-Warnungen behoben.


#ifndef _URS_TIME_h
#define _URS_TIME_h

#include <TimeLib.h>  // by Paul Stoffregen:   https://github.com/PaulStoffregen/Time
#include <Timezone.h> // by Jack Christensen:  https://github.com/JChristensen/Timezone

extern Timezone MEZ; // Vordefinierte Zeitzone MEZ

// Status der SystemZeit
enum class UrsSystemTimeState {
  timeNotSet,     // Die Systemzeit ist undefiniert
  timeNeedsSync,  // Die Systemzeit muss synchronisiert werden
  timeSet         // Die Systemzeit ist gltig
};

#ifdef DEBUG_URS_TIME
#define DEBUGT(...) Serial.printf(__VA_ARGS__)
#endif

#ifndef DEBUGT
#define DEBUGT(...)
#endif

#endif